###############################################################################
#
# <p>Discogs 򸡺</p>
# <pre>
#   {{discogs artist,title,year}}
# </pre>
#
###############################################################################
package plugin::discogs::Discogs;
use LWP::UserAgent;
use XML::Simple;
use JSON::XS qw/decode_json/;
use Encode qw /decode encode encode_utf8/;
use Storable qw/nstore retrieve/;
use URI::Escape;
use Data::Dumper;

#==============================================================================
# 󥹥ȥ饯
#==============================================================================
sub new {
  my $class = shift;
  my $self = {};
  $self->{count} = 1;
  return bless $self,$class;
}
#==============================================================================
# ѥ饰ե᥽å
#==============================================================================
sub paragraph {
  my $self = shift;
  my $wiki = shift;
  my $artist = shift;
  my $title = shift;
  my $date = shift;

  my $cgi = $wiki->get_CGI;
  my $pagename = $cgi->param("page");
  $pagename = &Util::url_encode($pagename);

  my $UserAgent = 'FSWiki Discogs Plugin/0.1 +http://mechanist.x0.com';

  my $index = $self->{count};
  my $buf = "<div class=\"discogs\"><table><tr><td rowspan=\"20\" width=\"150\">";

  #artistǸ
  my $artist_id;
  ($artist,$artist_id)= decide_name($self,$wiki,$artist);
  my $xml2 = get_xml($self,$wiki,'b',$artist_id);

  #artist
  if($xml2){
    my $count = 0;
    my $savefile = $wiki->config('image_dir')."/$pagename.$index.a.jpg";
    my $image = $xml2->{images}->[0]{uri150};

    my $link = "http://www.discogs.com/artist/".uri_escape(encode('utf8',$artist));
    save_image($wiki,$image,$savefile);
    my $tmp = "<a href=\"$link\" target=\"_blank\"><img src=\"".$wiki->config('image_dir')."/".&Util::url_encode($pagename).".$index.a.jpg\"></a>";
    $artist = encode('euc-jp', $artist);

    $buf .= $tmp."</td></tr><tr><td>Artist:</td><td><a href=\"$link\" target=\"_blank\">$artist</a></td></tr>";
    my $head = "Url:";
    foreach my $url (@{$xml2->{urls}}){
      unless(ref $url){
        $buf .= "<tr><td>$head</td><td><a href=\"$url\" target=\"_blank\">$url</a></td></tr>";
        $head = "";
      }
    }
  }
  $buf .= "</table>";

  $buf .= "<table><tr><td rowspan=\"200\" valign=\"top\" width=\"150\">";

  #releaseǸ
  my ($release,$release_id)= decide_release($self,$wiki,$artist_id,$title,$date);
  my $xml3 = get_xml($self,$wiki,'r',$release_id);

  #release
  if($xml3){
    my $count = 0;
    my $savefile = $wiki->config('image_dir')."/$pagename.$index.r.jpg";
    my $images = $xml3->{images}->[0];
    my $label = $xml3->{labels}->[0]{name};
    $date = $xml3->{year};
    my $link = "http://www.discogs.com/release/$release_id";
    my $tmp;
    foreach my $image ($images){
      if(($count == 0) || ($image->{type} eq 'primary')){
        $count++;
        save_image($wiki,$image->{uri150},$savefile);
        $tmp = "<a href=\"$link\" target=\"_blank\"><img src=\"".$wiki->config('image_dir')."/".&Util::url_encode($pagename).".$index.r.jpg\"></a>";
      }
    }
    $release = encode('euc-jp', $release);
    $buf .= $tmp."</td></tr><tr><td>Title:</td><td><a href=\"$link\" target=\"_blank\">$release</a></td></tr>";
    $label = encode('euc-jp', $label);
    $buf .= "<tr><td>Label:</td><td>$label</td></tr>";
    $buf .= "<tr><td>Released:</td><td>$date</td></tr><tr></tr>";
    my $head = "Track:";
    my $tracks = $xml3->{tracklist};
    foreach my $track (@$tracks){
      my $position = ref $track->{position} ? "-" : $track->{position};
      my $duration = ref $track->{duration} ? "-" : $track->{duration};
      if(($position eq "-") && ($duration eq "-")){
        $position = $duration = "";
      }else{
        $duration = "[".$duration."]";
      }
      my $title = ref $track->{title} ? "-" : $track->{title};
      $title = encode('euc-jp', $title);
      $buf .= "<tr><td>$head</td><td>$position\t$duration\t$title</td></tr>";
      $head = "";
    }
  }
  $buf .= "</table></div>";

  $self->{count}++;

  return $buf;
}


sub get_xml {
  my $self = shift;
  my $wiki = shift;
  my $mode = shift;
  my $word = shift;
  my $page = shift;

  unless($page){
    $page = 1;
  }

  my $cgi = $wiki->get_CGI;
  my $pagename = $cgi->param("page");
  $pagename = &Util::url_encode($pagename);

  $word = encode('utf8',$word);
  $word = word_encode($word);

  my $index = $self->{count};

  my $xml;
  my $cachefile = $wiki->config('log_dir')."/$pagename.$index.$mode.$page.dis";
  my $request_url = "http://api.discogs.com/";

  if((-e $cachefile) && !(&newerfile($cachefile, $wiki->config('data_dir')."/$pagename.wiki"))){
    $xml = retrieve $cachefile;
  }else{
    if($mode eq 'a'){
      #http://api.discogs.com/database/search?q=Aphex+Twin&per_page=50&page=<page>
      $request_url .= "database/search?q=".$word."&type=artist&per_page=50&page=".$page;
    }elsif($mode eq 'b'){
      #http://api.discogs.com/artists/<id>
      $request_url .= "artists/".$word;
    }elsif($mode eq 'l'){
      #http://api.discogs.com/aritsts/<id>/releases?per_page=50&page=<page>
      $request_url .= "artists/".$word."/releases?per_page=50&page=".$page;
    }elsif($mode eq 'm'){
      #http://api.discogs.com/masters/<id>
      $request_url .= "masters/".$word;
    }elsif($mode eq 'r'){
      #http://api.discogs.com/releases/<id>
      $request_url .= "releases/".$word;
    }else{
      #http://api.discogs.com/search?artist=Aphex+Twin
      $request_url .= "databese/search?artist=".$word;
    }

    my $ua = LWP::UserAgent->new;
    my $UserAgent = 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1; GTB5; .NET CLR 2.0.50727)';
    $ua->agent($UserAgent);
    my $res = $ua->get($request_url, 'Accept-Encoding' => 'gzip',);
    if($res->is_success){
      $xml = decode_json(encode_utf8($res->decoded_content));
      nstore $xml,$cachefile;
    }
  }

  return $xml;
}


sub decide_name {
  my $self = shift;
  my $wiki= shift;
  my $title = shift;

  my ($ret,$ret_id,$same,$same_id,$similar,$similar_id,$first,$first_id) = ();
  my $xml;
  $title = decode('euc-jp',$title);

  if ($title =~ /^##/){
    $title =~ s/##//;
    $xml = get_xml($self,$wiki,'b',$title);
    $same = $xml->{name};
    $same_id = $xml->{id};
  }else{
    $xml = get_xml($self,$wiki,'a',$title,1);

    my $items = $xml->{pagination}->{items};
    my $pages = $xml->{pagination}->{pages};

    for (my $i=1;$i<=$pages;$i++){
      $xml = get_xml($self,$wiki,'a',$title,$i);

      my $releases = $xml->{results};
      foreach my $release (@$releases){
        my $enc_title = $release->{title};
        if(($i == 1)&&(!$first)){
          $first = $enc_title;
          $first_id = $release->{id};
        }

        if($enc_title eq $title){
          $same = $release->{title};
          $same_id = $release->{id};
          last;
        }elsif($enc_title =~ $title){
          $similar = $release->{title};
          $similar_id = $release->{id};
        }
      }
    }
  }

  if($same){
    $ret = $same;
    $ret_id = $same_id;
  }elsif($similar){
    $ret = $similar;
    $ret_id = $similar_id;
  }else{
    $ret = $first;
    $ret_id = $first_id;
  }

  return ($ret,$ret_id);
}


sub decide_release {
  my $self = shift;
  my $wiki= shift;
  my $id = shift;
  my $title = shift;
  my $date = shift;

  my ($ret,$ret_id,$same,$same_id,$similar,$similar_id);

  $title = decode('euc-jp',$title);

  if ($title =~ /^##/){
    $title =~ s/##//;
    my $xml = get_xml($self,$wiki,'r',$title);
    $same = $xml->{title};
    $same_id = $xml->{id};
  }else{
    my $xml = get_xml($self,$wiki,'l',$id,1);
    my $items = $xml->{pagination}->{items};
    my $pages = $xml->{pagination}->{pages};

    for (my $i=1;$i<=$pages;$i++) {
      $xml = get_xml($self,$wiki,'l',$id,$i);

      my $releases = $xml->{releases};
      foreach my $release (@$releases) {
        my $enc_title = $release->{title};

        if ($enc_title eq $title) {
          if ($release->{year} eq $date) {
            $same = $release->{title};
            $same_id = $release->{main_release};
            unless($same_id){
              $same_id = $release->{id};
            }
            last;
          } else {
            $same = $release->{title};
            $same_id = $release->{main_release};
            unless($same_id){
              $same_id = $release->{id};
            }
          }
        } elsif ($enc_title =~ $title) {
          $similar = $release->{title};
          $similar_id = $release->{main_release};
          unless($similar_id){
            $similar_id = $release->{id};
          }
        }
      }
    }
  }

  if ($same){
    $ret = $same;
    $ret_id = $same_id;
  }elsif($similar){
    $ret = $similar;
    $ret_id = $similar_id;
  }

  return ($ret,$ret_id);
}


sub save_image {
  my $wiki = shift;
  my $uri = shift;
  my $file = shift;

  my $cgi = $wiki->get_CGI;
  my $pagename = $cgi->param("page");
  $pagename = &Util::url_encode($pagename);

  if((-e $file) && !(&newerfile($file, $wiki->config('data_dir')."/$pagename.wiki"))){
  }else{
    my $UserAgent = 'FSWiki Discogs Plugin/0.1 +http://mechanist.x0.com';
    my $ua = LWP::UserAgent->new;
    $ua->agent($UserAgent);
    my $res = $ua->get($uri);
    if($res->is_success){
      my $out = IO::File->new($file, 'w');
      $out->binmode();
      $out->write($res->content, $res->content_length);
      $out->close();
    }
  }
}


sub newerfile {
    my $criterion = shift;	# ˤʤե
    my $file = shift;	# Ӥե

  if ((stat($criterion))[9] < (stat($file))[9]){
    return 1;
  }else{
    return 0;
  }
}


sub word_encode {
	my $retstr = shift;
	$retstr =~ s/([^ 0-9A-Za-z])/sprintf("%%%.2X", ord($1))/eg;
	$retstr =~ tr/ /+/;
	return $retstr;
}


1;
